with Names;

package UnitMgr is

   use Names;

   Units : Units_T;

   First_State : array (Mode_T, Unit_ID_T) of Branch_State_T := (
      --
      Off | Standby => (others => Off),
      --
      Safe => (
         ES | SS | RW => On,
         others => Off),
      --
      Nominal => (
         STR | RW | THR => On,
         GPS => GPS_Coarse_Navigation,
         others => Off),
      --
      Preparation => (
         STR | RW | THR => On,
         GPS   => GPS_Fine_Navigation,
         PLI   => PLI_Standby,
         others => Off),
      --
      Science => (
         STR | RW | THR => On,
         GPS   => GPS_Fine_Navigation,
         PLI   => PLI_Science,
         others => Off) );


   procedure Main;

   function Redundancy_Available (UnId : Unit_ID_T) return Boolean;

   procedure Abort_All_Reconfigurations;

   procedure Start_Switch_To_Redundant (UnId : Unit_ID_T);

   procedure Start_Transition_Br (
      UnId : Unit_ID_T;
      BrId : Branch_ID_T;
      Target_State : Branch_State_T );

   procedure Start_Transition_U (
      UnId : Unit_ID_T;
      Target_State : Branch_State_T );

   procedure Release (UnId : Unit_ID_T);

   procedure Release_All;

   function All_Off return Boolean;


   procedure Start_Mode_Specific_Unit_Conf (Mode : Mode_T);

   function Unit_Conf_Done (Mode : Mode_T) return Boolean;

   procedure Lock_All_Selected (Mode : Mode_T);

   procedure Lock (UnId : Unit_ID_T);

   function State_by_U_Is (
      UnId : Unit_ID_T;
      State : Branch_State_T )
   return Boolean;

   function No_Reconfiguration return Boolean;

end UnitMgr;
